unit login_screen;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Edit, FMX.Controls.Presentation, FMX.ListView.Types,
  FMX.ListView.Appearances, FMX.ListView.Adapters.Base, FMX.ListView,
  Xml.xmldom, Xml.XMLIntf, Xml.XMLDoc;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    XMLDocument1: TXMLDocument;
    procedure Button1Click(Sender: TObject);
    function EnDeCrypt(const Value : String) : String;
    function passwordStrong(const s: AnsiString) : boolean;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  main_password: string;
  filename: string;

implementation

{$R *.fmx}

uses main_screen;

function TForm2.EnDeCrypt(const Value : String) : String;
var
  CharIndex : integer;
begin
// Simple encryption, change 1 for 0 and 0 for 1
  Result := Value;
  for CharIndex := 1 to Length(Value) do
    Result[CharIndex] := chr(not(ord(Value[CharIndex])));
end;

procedure TForm2.Button1Click(Sender: TObject);
var
XMLDocument : IXMLDocument;
passwords: IXMLNode;
passwordlist: IXMLNodeList;
begin
  // if data.xml exists, check if the entered password is correct and log in
  if FileExists(filename) then begin
    if edit1.text = main_password then begin
      Form1.Show;
      Form2.Hide;
    end
    else begin
    // if entered password is incorrect, notify user
      label2.Text := 'Het ingevoerde wachtwoord is onjuist';
    end;
  end
  else begin
    // if data.xml doesn't exist, create it
    XMLDocument := NewXMLDocument;
    XMLDocument.Encoding := 'utf-8';
    XMLDocument.Options := [doNodeAutoIndent];
    if passwordStrong(edit1.text) = true then begin
      //save the main password
      passwords := XMLDocument.AddChild('passwords');
      passwords.AddChild('login').Text := EnDeCrypt(edit1.Text);
      XMLDocument.SaveToFile(filename);

      //notify user and open main screen
      ShowMessage('Het wachtwoord is ingesteld.');
      Form1.Show;
      Form2.Hide;
    end
    else begin
      ShowMessage('Het ingevoerde wachtwoord is niet sterk genoeg. Gebruik minimaal 8 tekens, met kleine letters, hoofdletters, cijfers en een speciaal teken (!, #, %, &, *, @)');
    end;
  end;
  
end;

procedure TForm2.FormCreate(Sender: TObject);
var
XMLDocument : IXMLDocument;
passwords: IXMLNode;
passwordlist: IXMLNodeList;
begin
//set up the filename
filename := 'data.xml';
  // if data.xml exists, open it
  if FileExists(filename) then begin
    XMLDocument1.FileName := filename;
    XMLDocument1.Active := True;

    //set the main password variable to the password in data.xml
    try
      passwords := XMLDocument1.DocumentElement;
      main_password := EnDeCrypt(passwords.ChildNodes['login'].Text);
    finally
      XMLDocument1.Active := False;
    end;
  end
  else begin
  // notify user that he has to enter a password
    label1.Text := 'Stel een wachtwoord in';
  end;
end;


//function for checking if password is strong enough
function TForm2.passwordStrong(const s: AnsiString): Boolean;
const
  C_Upcase = 1;
  C_Locase = 2;
  C_Digit = 4;
  C_SpecSym = 8;
  C_All = C_Upcase or C_Locase or C_Digit or C_SpecSym;
var
  i, keys: integer;
begin

  if True then

  if Length(s) < 8 then begin
    Result := False;
    Exit;
  end;

  keys := 0;
  for i := 1 to Length(s) do
    case s[i] of
      'A'..'Z': keys := keys or C_Upcase;
      'a'..'z': keys := keys or C_Locase;
      '0'..'9': keys := keys or C_Digit;
      '!','#','%','&','*','@': keys := keys or C_SpecSym;
    end;

  Result := keys = C_All;
end;

end.
