unit main_screen;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Layouts,
  FMX.ListBox, FMX.ListView.Types, FMX.ListView.Appearances,
  FMX.ListView.Adapters.Base, FMX.ListView, FMX.Menus, Xml.xmldom, Xml.XMLIntf,
  Xml.XMLDoc, FMX.StdCtrls, FMX.Controls.Presentation;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    ListBox1: TListBox;
    XMLDocument1: TXMLDocument;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure MenuItem2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function EnDeCrypt(const Value : String) : String;
    procedure refreshListbox() ;
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  password, id: string;


implementation

{$R *.fmx}

uses new_password_screen, login_screen,
  System.Rtti, FMX.Platform, FMX.Surfaces;

procedure TForm1.Button2Click(Sender: TObject);
var
passwords, entry: IXMLNode;
passwordlist: IXMLNodeList;
i: Integer;
begin
//ask if the user is sure he wants to delete the password
  if MessageDlg('Weet u zeker dat u het wachtwoord wilt verwijderen?', TMsgDlgType.mtConfirmation, mbYesNo,0) = mrYes then begin

    // if data.xml exists, open the file
    if FileExists(filename) then begin
      XMLDocument1.FileName := filename;
      XMLDocument1.Active := True;

      try
        // set up some variables
        passwords := XMLDocument1.DocumentElement;
        passwords := passwords.ChildNodes['saved'];
        passwordlist := passwords.ChildNodes;

        // find the entry that should be deleted
        for i := passwordlist.Count - 1 downto 0 do begin
          if passwordlist[i].Attributes['id'] = id then begin
            entry := passwordlist[i];
            // delete it
            passwordlist.Remove(entry);
            XMLDocument1.SaveToFile(filename);
            refreshListbox();
            GroupBox1.Text := 'Geen wachtwoorden aangemaakt';
            Label3.Text := 'Onbekend';
            password := 'Onbekend';
          end;
        end;
      finally
        XMLDocument1.Active := False;
      end;
    end;
  end;
end;

procedure TForm1.refreshListBox();
var
passwords, entry: IXMLNode;
passwordlist: IXMLNodeList;
number_of_passwords, i: integer;
begin
// clear the listbox
Listbox1.Items.Clear;
  // check if data.xml exists
  if FileExists(filename) then begin
    try
    // set up some variables
      XMLDocument1.FileName := filename;
      XMLDocument1.Active := True;

      try
      // set up some other variables
        passwords := XMLDocument1.DocumentElement;
        passwords := passwords.ChildNodes['saved'];
        passwordlist := passwords.ChildNodes;

        number_of_passwords := passwordlist.Count;

        // add entries from data.xml to the listbox
        for i := 0 to number_of_passwords - 1 do begin
          entry := passwordlist[i];
          Listbox1.Items.Add(entry.ChildNodes['name'].Text);
        end;
      finally
      XMLDocument1.Active := False;
      end;
    except
    end;

  end;
end;

function TForm1.EnDeCrypt(const Value : String) : String;
var
  CharIndex : integer;
begin
// Simple encryption, change 1 for 0 and 0 for 1
  Result := Value;
  for CharIndex := 1 to Length(Value) do
    Result[CharIndex] := chr(not(ord(Value[CharIndex])));
end;


procedure TForm1.Button1Click(Sender: TObject);
var
  Svc: IFMXClipboardService;
begin
// copy password to clipboard
  if TPlatformServices.Current.SupportsPlatformService(IFMXClipboardService, Svc) then begin
      Svc.SetClipboard(password);
    end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  refreshListbox();
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// close form 2 when form 1 closes
   Form2.Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
passwords: IXMLNode;
passwordlist: IXMLNodeList;
begin
// set the filename
  filename := 'data.xml';
  // if there is a data.xml, open it
  if FileExists(filename) then begin
    XMLDocument1.FileName := filename;
    XMLDocument1.Active := True;

    try
      try
      // set up some variables
        passwords := XMLDocument1.DocumentElement;
        passwords := passwords.ChildNodes['saved'];
        passwordlist := passwords.ChildNodes;

        // when no node has been selected yet, load in first node
        GroupBox1.Text := passwordlist[0].ChildNodes['name'].Text;
        Label3.Text := passwordlist[0].ChildNodes['username'].Text;
        password := EnDeCrypt(passwordlist[0].ChildNodes['password'].Text);
        id :=  passwordlist[0].Attributes['id'];
      except
        // if there are no passwords, notify user
        GroupBox1.Text := 'Geen wachtwoorden aangemaakt';
        Label3.Text := 'Onbekend';
        password := 'Onbekend';
      end;
    finally
      XMLDocument1.Active := False;
    end;
  end
  else begin
  // if there is no data.xml file, notify user
    GroupBox1.Text := 'Geen wachtwoorden aangemaakt';
    Label3.Text := 'Onbekend';
    password := 'Onbekend';
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var selectedItem : integer;
passwords: IXMLNode;
passwordlist: IXMLNodeList;
begin
// get the position of the selected listbox item
  with ListBox1 do
  begin
    if (Selected = nil) then exit;
    selectedItem := Listbox1.ItemIndex;
  end;

  // if data.xml exists, open the file
  if FileExists(filename) then begin
    XMLDocument1.FileName := filename;
    XMLDocument1.Active := True;

    try
      // set up some variables
      passwords := XMLDocument1.DocumentElement;
      passwords := passwords.ChildNodes['saved'];
      passwordlist := passwords.ChildNodes;

      //show data of selected password
      GroupBox1.Text := passwordlist[selectedItem].ChildNodes['name'].Text;
      Label3.Text := passwordlist[selectedItem].ChildNodes['username'].Text;
      password := EnDeCrypt(passwordlist[selectedItem].ChildNodes['password'].Text);
      id :=  passwordlist[selectedItem].Attributes['id'];
    finally
      XMLDocument1.Active := False;
    end;
  end;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
// open new password creation form
  Form3.ShowModal;
end;

end.
