unit new_password_screen;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation, FMX.Edit, Xml.xmldom, Xml.XMLIntf, Xml.XMLDoc;

type
  TForm3 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Label1: TLabel;
    XMLDocument1: TXMLDocument;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    function EnDeCrypt(const Value : String) : String;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.fmx}

uses main_screen, login_screen;

function TForm3.EnDeCrypt(const Value : String) : String;
var
  CharIndex : integer;
begin
// Simple encryption, change 1 for 0 and 0 for 1
  Result := Value;
  for CharIndex := 1 to Length(Value) do
    Result[CharIndex] := chr(not(ord(Value[CharIndex])));
end;

procedure TForm3.Button1Click(Sender: TObject);
var
XMLDocument : IXMLDocument;
passwords, entry: IXMLNode;
passwordlist: IXMLNodeList;
id: string;
begin
  // check if all fields are filled in
  if (Edit1.Text <> '') and (Edit2.Text <> '') and (Edit3.Text <> '') then begin

    // Set up some variables
    XMLDocument1.Filename := filename;
    XMLDocument1.Active := True;

    try //try to get the id of the last node, if not possible (there is no node), set id to 1
      passwords := XMLDocument1.DocumentElement;
      try
        passwords := passwords.ChildNodes['saved'];
        passwordlist := passwords.ChildNodes;

        entry := passwordlist[passwordlist.Count - 1];

        id := IntToStr(StrToInt(entry.Attributes['id']) + 1);
      except
        passwordlist := passwords.ChildNodes;

        id := '1';
      end;

      //create the node and save the file
      XMLDocument1.Options := [doNodeAutoIndent];

      entry := passwords.AddChild('entry');
      entry.Attributes['id'] := id;

      entry.AddChild('name').Text := Edit1.Text;
      entry.AddChild('username').Text := Edit2.Text;
      entry.AddChild('password').Text := EnDeCrypt(Edit3.Text);

      XMLDocument1.SaveToFile(filename);
    finally
      XMLDocument1.Active := False;
    end;

  // notify user of succes and clear fields
  ShowMessage('Het wachtwoord is opgeslagen.');
  Edit1.Text := '';
  Edit2.Text := '';
  Edit3.Text := '';
  Form3.Close;

  end
  else begin
    // if not all fields are filled in, notify user
    Label2.Text := 'Vul a.u.b. alle velden in.';
  end;
end;

end.
